<template>
  <div class="flex px-4" :class="show ? 'fadeInRight' : 'hidden'">
    <div :class="[!register.IsHidden ? 'w-5/6' : 'w-full']">
      <div
        class="py-10 px-4 bg-white bg-opacity-25 rounded-tl-xl rounded-bl-xl"
      >
        <h2 class="mb-10 text-[7vw] text-center text-white font-bold">
          {{ $t("capital_login") }}
        </h2>
        <el-form
          :show-message="true"
          label-position="top"
          ref="loginFormRef"
          :model="loginFormData"
          :rules="loginRules"
          :validate-on-rule-change="false"
          class="w-full mx-auto login-form"
        >
          <div class="flex flex-col gap-[3vw]">
            <el-form-item prop="Username">
              <el-input
                class="text-white"
                v-model="loginFormData.Username"
                :placeholder="$t('username')"
                type="text"
              >
                <template #prefix>
                  <div class="flex items-center">
                    <img
                      class="h-[6vw]"
                      :src="
                        getAssetImage(
                          'assets/theme/light_flexible_1/mobile/images/user.png'
                        )
                      "
                      alt=""
                    />
                  </div>
                </template>
              </el-input>
            </el-form-item>
            <el-form-item prop="Password">
              <el-input
                class="text-white"
                v-model="loginFormData.Password"
                :placeholder="$t('password')"
                type="password"
              >
                <template #prefix>
                  <div class="flex items-center">
                    <img
                      class="h-[6vw]"
                      :src="
                        getAssetImage(
                          'assets/theme/light_flexible_1/mobile/images/padlock.png'
                        )
                      "
                      alt=""
                    />
                  </div>
                </template>
              </el-input>
            </el-form-item>
            <div class="btn-click-captcha-to-verify">
              <el-form-item
                prop="Captcha"
                :show-message="true"
                v-if="!clientCaptcha.IsHidden"
              >
                <div id="captcha-button">
                  <div id="captcha-pop-up-verify" class="w-full">
                    <template
                      v-if="
                        !captchaErrorMsg.length &&
                        loginFormData.Captcha.length == 5 &&
                        !isDialogVisible
                      "
                    >
                      <div class="relative w-[18px] h-[18px]">
                        <img
                          :src="
                            getAssetImage(
                              'assets/theme/light_flexible_1/desktop/images/menu/captcha-success.png'
                            )
                          "
                          alt="verify icon success"
                        />
                      </div>
                      <span class="whitespace-nowrap">{{
                        $t("successful_verification")
                      }}</span>
                    </template>
                    <template v-else>
                      <div
                        class="flex justify-center items-center gap-1 w-full"
                        @click="isDialogVisible = true"
                      >
                        <div class="relative w-[18px] h-[18px]">
                          <img
                            :src="
                              getAssetImage(
                                'assets/theme/light_flexible_1/desktop/images/menu/capcha.png'
                              )
                            "
                            alt="verify icon"
                          />
                        </div>
                        <span>{{ $t("click_to_verify") }}</span>
                      </div>
                    </template>
                  </div>
                </div>
              </el-form-item>
            </div>
            <el-form-item class="forgot-password-form-item">
              <auth-forgot-password-modal :fullscreen="true" />
            </el-form-item>
            <el-button
              class="h-[13.5vw] bg-gradient-to-r from-sky-500 to-indigo-500 rounded-full"
              style="border-radius: 9999px"
              :disabled="isLoginProccessing"
              @click="submitLogin(loginFormRef)"
            >
              <span
                class="text-2xl text-center text-white bg-opacity-25 font-light"
                >{{ $t("capital_login") }}</span
              >
            </el-button>
            <span
              class="cursor-pointer text-xl font-medium px-2 text-white mb-7"
              @click="goHome"
              >{{ $t("skip_login") }}</span
            >
            <theme-common-telegram-login-button
              :is-show="isTelegramBotSetup"
              :username="telegramBotUsername"
              @callback="telegramCallbackFunction"
            />
          </div>
        </el-form>
      </div>
    </div>

    <div class="w-1/6" @click="toggleRegister" v-if="!register.IsHidden">
      <div
        class="bg-black bg-opacity-50 h-full text-white rounded-tr-xl rounded-br-xl grid gap-10 place-content-center"
        :id="ID.SIGNUP"
      >
        <div class="py-10 flex flex-col items-center gap-4 pointer-events-none">
          <img
            class="max-w-[8vw] h-auto"
            :src="
              getAssetImage(
                'assets/theme/light_flexible_1/mobile/images/register.png'
              )
            "
            alt="img"
          />
          <div
            class="flex flex-col jutify-center items-center text-xl font-bold text-[5vw]"
            style="writing-mode: vertical-rl"
          >
            {{ $t("joinnow") }}
          </div>
        </div>
      </div>
    </div>
  </div>
  <div class="captcha-dialog-container">
    <el-dialog
      align-center
      destroy-on-close
      :show-close="false"
      custom-class="p-[15px] captcha-dialog"
      v-model="isDialogVisible"
      width="320px"
      @open="loginFormData.Captcha = ''"
      @close="loginFormRef?.validateField('Captcha')"
    >
      <utils-client-captcha
        v-if="!clientCaptcha.IsHidden"
        v-model:captcha="loginFormData.Captcha"
        v-model:dialogVisible="isDialogVisible"
        :get-error-message="getCaptchaErrorMsg"
        :is-invalid="captchaErrorMsg.length > 0"
      />
    </el-dialog>
  </div>
</template>

<script lang="ts">
import { defineComponent, ref } from "vue";
import useLogin from "@/composables/useLogin";
import { clientCaptcha } from "@/composables/captcha/useCaptcha";

export default defineComponent({
  name: "LoginComponent",
  props: {
    show: {
      type: Boolean,
      required: true,
    },
  },
  emits: ["toggleRegister"],
  setup(props, { emit }) {
    const router = useRouter();
    const {
      loginFormRef,
      loginFormData,
      loginRules,
      submitLogin,
      isLoginProccessing,
      captchaErrorMsg,
      getCaptchaErrorMsg,
      register,
      isTelegramBotSetup,
      telegramBotUsername,
      telegramCallbackFunction,
      checkLoginTelegramSetup,
    } = useLogin();
    checkLoginTelegramSetup();
    const toggleRegister = () => {
      emit("toggleRegister");
    };
    function addMinutes(numOfMinutes: number, date = new Date()) {
      date.setMinutes(date.getMinutes() + numOfMinutes);
      return date;
    }
    const goHome = () => {
      document.cookie = `skipLogin=true;expires=${addMinutes(10)};path=/`;
      router.replace("/");
    };
    const isDialogVisible = ref(false);
    const { getAssetImage } = commonHelper;
    return {
      toggleRegister,
      loginFormRef,
      loginFormData,
      loginRules,
      submitLogin,
      isLoginProccessing,
      isDialogVisible,
      clientCaptcha,
      captchaErrorMsg,
      getCaptchaErrorMsg,
      getAssetImage,
      goHome,
      register,
      isTelegramBotSetup,
      telegramBotUsername,
      telegramCallbackFunction,
    };
  },
});
</script>
<style scoped>
.login-btn {
  opacity: 0.5;
  color: white;
  font-size: 24px;
  font-weight: 300;
}
:deep(.el-input) {
  @apply bg-black bg-opacity-25 h-[13.5vw] px-6 rounded-full flex gap-3 items-center;
}
:deep(.el-form-item__error) {
  @apply px-5;
  position: unset;
  padding-top: 5px;
  font-size: 16px;
}
:deep(.el-input__inner) {
  background-color: transparent;
  height: 24px;
}
:deep(.el-form-item) {
  margin-bottom: 0;
}
:deep(.el-form-item__label) {
  color: white;
  font-weight: bold;
}
:deep(.el-button) {
  @apply h-[13.5vw];
}
:deep(.el-button.el-button--danger) {
  --el-button-bg-color: green;
}
:deep(
    .el-input__inner:-webkit-autofill,
    .el-input__inner:-webkit-autofill:hover,
    .el-input__inner:-webkit-autofill:focus,
    .el-input__inner:-webkit-autofill:active
  ) {
  transition: background-color 50000s ease-in-out 0s, color 5000s ease-in-out 0s;
  -webkit-text-fill-color: #fff;
}
</style>
